org.apache.commons.net.tftp

## Class TFTPDataPacket

- java.lang.Object
- - org.apache.commons.net.tftp.TFTPPacket
  - - org.apache.commons.net.tftp.TFTPDataPacket

-     public final class TFTPDataPacket
      extends TFTPPacket

  A final class derived from TFTPPacket defining the TFTP Data packet type.

  Details regarding the TFTP protocol and the format of TFTP packets can be found in RFC 783. But the point of these classes is to keep you from having to worry about the internals. Additionally, only very few people should have to care about any of the TFTPPacket classes or derived classes. Almost all users should only be concerned with the `TFTPClient` class `receiveFile()` and `sendFile()` methods.

  See Also:
    `TFTPPacket`, `TFTPPacketException`, `TFTP`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) int` | `blockNumber` The block number of the packet.
    `static int` | `MAX_DATA_LENGTH` The maximum number of bytes in a TFTP data packet (512)
    `static int` | `MIN_DATA_LENGTH` The minimum number of bytes in a TFTP data packet (0)

    - ### Fields inherited from class org.apache.commons.net.tftp.TFTPPacket

      `ACKNOWLEDGEMENT, address, DATA, ERROR, MIN_PACKET_SIZE, OACK, port, READ_REQUEST, SEGMENT_SIZE, type, WRITE_REQUEST`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TFTPDataPacket(DatagramPacket datagram)` Creates a data packet based from a received datagram.
    `TFTPDataPacket(InetAddress destination, int port, int blockNumber, byte[] data)` Creates a data packet to be sent to a host at a given port with a given block number.
    `TFTPDataPacket(InetAddress destination, int port, int blockNumber, byte[] data, int offset, int length)` Creates a data packet to be sent to a host at a given port with a given block number.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getBlockNumber()` Gets the block number of the data packet.
    `byte[]` | `getData()` Gets the byte array containing the packet data.
    `int` | `getDataLength()` Gets the length of the data part of the data packet.
    `int` | `getDataOffset()` Gets the offset into the byte array where the packet data actually starts.
    `DatagramPacket` | `newDatagram()` Creates a UDP datagram containing all the TFTP data packet data in the proper format.
    `(package private) DatagramPacket` | `newDatagram(DatagramPacket datagram, byte[] data)` This is a method only available within the package for implementing efficient datagram transport by eliminating buffering.
    `void` | `setBlockNumber(int blockNumber)` Sets the block number of the data packet.
    `void` | `setData(byte[] data, int offset, int length)` Sets the data for the data packet.
    `String` | `toString()` For debugging

    - ### Methods inherited from class org.apache.commons.net.tftp.TFTPPacket

      `getAddress, getPort, getType, newTFTPPacket, setAddress, setPort`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### blockNumber

          int blockNumber

      The block number of the packet.

    - #### MAX_DATA_LENGTH

          public static final int MAX_DATA_LENGTH

      The maximum number of bytes in a TFTP data packet (512)
      See Also:
        Constant Field Values

    - #### MIN_DATA_LENGTH

          public static final int MIN_DATA_LENGTH

      The minimum number of bytes in a TFTP data packet (0)
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### TFTPDataPacket

          TFTPDataPacket(DatagramPacket datagram)
                  throws TFTPPacketException

      Creates a data packet based from a received datagram. Assumes the datagram is at least length 4, else an ArrayIndexOutOfBoundsException may be thrown.
      Parameters:
        `datagram` - The datagram containing the received data.
      Throws:
        `TFTPPacketException` - If the datagram isn't a valid TFTP data packet.

    - #### TFTPDataPacket

          public TFTPDataPacket(InetAddress destination,
                                int port,
                                int blockNumber,
                                byte[] data)

      Creates a data packet to be sent to a host at a given port with a given block number. The actual data to be sent is passed as an array, an offset, and a length. The offset is the offset into the byte array where the data starts. The length is the length of the data.
      Parameters:
        `destination` - The host to which the packet is going to be sent.
        `port` - The port to which the packet is going to be sent.
        `blockNumber` - The block number of the data.
        `data` - The byte array containing the data.

    - #### TFTPDataPacket

          public TFTPDataPacket(InetAddress destination,
                                int port,
                                int blockNumber,
                                byte[] data,
                                int offset,
                                int length)

      Creates a data packet to be sent to a host at a given port with a given block number. The actual data to be sent is passed as an array, an offset, and a length. The offset is the offset into the byte array where the data starts. The length is the length of the data.
      Parameters:
        `destination` - The host to which the packet is going to be sent.
        `port` - The port to which the packet is going to be sent.
        `blockNumber` - The block number of the data.
        `data` - The byte array containing the data.
        `offset` - The offset into the array where the data starts.
        `length` - The length of the data.

  - ### Method Detail

    - #### getBlockNumber

          public int getBlockNumber()

      Gets the block number of the data packet.
      Returns:
        The block number of the data packet.

    - #### getData

          public byte[] getData()

      Gets the byte array containing the packet data.
      Returns:
        The byte array containing the packet data.

    - #### getDataLength

          public int getDataLength()

      Gets the length of the data part of the data packet.
      Returns:
        The length of the data part of the data packet.

    - #### getDataOffset

          public int getDataOffset()

      Gets the offset into the byte array where the packet data actually starts.
      Returns:
        The offset into the byte array where the packet data actually starts.

    - #### newDatagram

          public DatagramPacket newDatagram()

      Creates a UDP datagram containing all the TFTP data packet data in the proper format. This is a method exposed to the programmer in case he wants to implement his own TFTP client instead of using the `TFTPClient` class. Under normal circumstances, you should not have a need to call this method.
      Specified by:
        `newDatagram` in class `TFTPPacket`
      Returns:
        A UDP datagram containing the TFTP data packet.

    - #### newDatagram

          DatagramPacket newDatagram(DatagramPacket datagram,
                                     byte[] data)

      This is a method only available within the package for implementing efficient datagram transport by eliminating buffering. It takes a datagram as an argument, and a byte buffer in which to store the raw datagram data. Inside the method, the data is set as the datagram's data and the datagram returned.
      Specified by:
        `newDatagram` in class `TFTPPacket`
      Parameters:
        `datagram` - The datagram to create.
        `data` - The buffer to store the packet and to use in the datagram.
      Returns:
        The datagram argument.

    - #### setBlockNumber

          public void setBlockNumber(int blockNumber)

      Sets the block number of the data packet.
      Parameters:
        `blockNumber` - the number to set

    - #### setData

          public void setData(byte[] data,
                              int offset,
                              int length)

      Sets the data for the data packet.
      Parameters:
        `data` - The byte array containing the data.
        `offset` - The offset into the array where the data starts.
        `length` - The length of the data.

    - #### toString

          public String toString()

      For debugging
      Overrides:
        `toString` in class `TFTPPacket`